VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   2415
      Left            =   0
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   0
      Width           =   2775
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Get the name and number of the latest version of the file.
Private Sub GetLatestName(ByVal file_name As String, ByRef latest_name As String, ByRef latest_number As Integer)
Dim pos As Integer
Dim file_title As String
Dim file_path As String
Dim len_before As Integer
Dim len_after As Integer
Dim fname As String
Dim num As Integer

    ' Get the file's title and path.
    pos = InStrRev(file_name, "\")
    file_title = Mid$(file_name, pos + 1)
    file_path = Left$(file_name, pos)

    ' Get the part of the file title before and after the *.
    pos = InStr(file_title, "*")
    len_before = pos - 1
    len_after = Len(file_title) - pos

    ' Look for matching files.
    fname = Dir$(file_name)
    latest_number = -1
    latest_name = ""
    Do While Len(fname) > 0
        On Error Resume Next
        num = CInt(Mid$(fname, len_before + 1, Len(fname) - len_before - len_after))
        If Err.Number <> 0 Then
            Err.Clear
        Else
            If latest_number < num Then
                latest_number = num
                latest_name = file_path & fname
            End If
        End If
        On Error GoTo 0

        fname = Dir$()
    Loop
End Sub
' Purge files with version numbers before this one.
Private Sub PurgeVersionsBefore(ByVal file_name As String, ByRef purge_before As Integer)
Dim pos As Integer
Dim file_title As String
Dim file_path As String
Dim len_before As Integer
Dim len_after As Integer
Dim fname As String
Dim num As Integer

    ' Get the file's title and path.
    pos = InStrRev(file_name, "\")
    file_title = Mid$(file_name, pos + 1)
    file_path = Left$(file_name, pos)

    ' Get the part of the file title before and after the *.
    pos = InStr(file_title, "*")
    len_before = pos - 1
    len_after = Len(file_title) - pos

    ' Look for matching files.
    fname = Dir$(file_name)
    Do While Len(fname) > 0
        On Error Resume Next
        num = CInt(Mid$(fname, len_before + 1, Len(fname) - len_before - len_after))
        If Err.Number <> 0 Then
            Err.Clear
        Else
            If num < purge_before Then
                Kill file_path & fname
            End If
        End If
        On Error GoTo 0

        fname = Dir$()
    Loop
End Sub

' Get the latest version of the file.
Private Function GetLatestContents(ByVal file_name As String) As String
Dim latest_name As String
Dim latest_number As Integer

    ' Get the latest file's name.
    GetLatestName file_name, latest_name, latest_number

    ' Read the file.
    If Len(latest_name) = 0 Then
        GetLatestContents = ""
    Else
        On Error Resume Next
        GetLatestContents = GetFileContents(latest_name)
        If Err.Number <> 0 Then GetLatestContents = ""
    End If
End Function
' Get the latest version of the file.
Private Sub SetLatestContents(ByVal file_name As String, ByVal version_format As String, ByVal new_contents As String, Optional ByVal keep_versions = 0)
Dim latest_name As String
Dim latest_number As Integer

    ' Get the latest file's name.
    GetLatestName file_name, latest_name, latest_number

    ' Add one to the version.
    latest_number = latest_number + 1

    ' Wrap around after 999 (you could change this for your application).
    If latest_number > 1000 Then latest_number = 1
    latest_name = Replace$(file_name, "*", Format$(latest_number, version_format))

    ' Save the file.
    SetFileContents latest_name, new_contents

    ' See if we should purge old versions.
    If keep_versions > 0 Then
        PurgeVersionsBefore file_name, latest_number - keep_versions + 1
    End If
End Sub

' Set the file's contents.
Private Sub SetFileContents(ByVal file_name As String, ByVal contents As String)
Dim fnum As Integer

    ' Open the file.
    fnum = FreeFile
    Open file_name For Output As fnum

    ' Write the file's contents (without an
    ' extra trailing vbCrLf).
    Print #fnum, contents;

    ' Close the file.
    Close fnum
End Sub
' Get the file's contents.
Private Function GetFileContents(ByVal file_name As String) As String
Dim fnum As Integer

    ' Open the file.
    fnum = FreeFile
    Open file_name For Input As fnum

    ' Grab the file's contents.
    GetFileContents = Input(LOF(fnum), fnum)

    ' Close the file.
    Close fnum
End Function


Private Sub Form_Load()
Dim file_name As String

    ' Compose the file name.
    ' The "*" marks the version number.
    file_name = App.Path
    If Right$(App.Path, 1) <> "\" Then file_name = file_name & "\"
    file_name = file_name & "test.*.txt"

    ' Get the file's text.
    Text1.Text = GetLatestContents(file_name)
End Sub

Private Sub Form_Resize()
    Text1.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


' Save the new text contents.
Private Sub Form_Unload(Cancel As Integer)
Dim file_name As String

    ' Compose the file name.
    ' The "*" marks the version number.
    file_name = App.Path
    If Right$(App.Path, 1) <> "\" Then file_name = file_name & "\"
    file_name = file_name & "test.*.txt"

    SetLatestContents file_name, "000", Text1.Text, 3
End Sub


